import javax.swing.*;
import java.awt.*;
import java.util.Map;
import java.util.HashMap;
import java.util.Arrays;
import java.util.ArrayList;
import javax.swing.tree.DefaultMutableTreeNode;
import java.util.Map.Entry;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;

public class AddParamDialog extends JDialog {
	JButton save, close;
	JTextField name;
	JComboBox type;
	Object[] returnVal = null;
	
	public enum AddParamDialogMode {
		Add, Edit
	}

	public AddParamDialog(Window owner, AddParamDialogMode mode) {
		super(owner, Dialog.ModalityType.APPLICATION_MODAL);
		setSize(new Dimension(315, 150));
		setResizable(false);
		setLocationRelativeTo(owner);
		Container contentPane = this.getContentPane();
		setLayout(null);
		setTitle("Add Parameter");
		
		
		JLabel nameLabel = new JLabel("Name:");
		nameLabel.setLocation(15, 15);
		nameLabel.setSize(80, 20);

		name = new JTextField();
		name.setLocation(80, 15);
		name.setSize(210, 20);
		
		JLabel typeLabel = new JLabel("Type:");
		typeLabel.setLocation(15, 45);
		typeLabel.setSize(80, 20);

		type = new JComboBox(XSlot.ParamType.values());
		type.setLocation(80, 45);
		type.setSize(210, 20);
		
		close = new JButton("Cancel");
		close.setSize(80, 28);
		close.setLocation(125, 80);
		
		save = new JButton("Add");
		save.setSize(80, 28);
		save.setLocation(210, 80);
		
		this.getRootPane().setDefaultButton(save);
		
		ActionListener buttonActionListener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (e.getSource() == save) {
					returnVal = new Object[2];
					returnVal[0] = name.getText();
					returnVal[1] = type.getSelectedItem();
					dispose();
				} else if (e.getSource() == close) {
					dispose();
				}
			}
		};
		
		save.addActionListener(buttonActionListener);
		close.addActionListener(buttonActionListener);
		
		add(nameLabel);
		add(name);
		add(typeLabel);
		add(type);
		add(close);
		add(save);
	}
	
	Object[] showDialog() {
		setVisible(true);
		return returnVal;
	}
}
