import java.util.Map;
import java.util.HashMap;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import java.awt.Component;

class ComponentTreeIconRenderer extends DefaultTreeCellRenderer {
	Map<String, ImageIcon> icons = new HashMap<String, ImageIcon>();
	ImageIcon arrow_expand, arrow_expanded;
	
	public ComponentTreeIconRenderer() {
		icons.put("Button", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/button.png")));
		icons.put("Text Box", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/textbox.png")));
		icons.put("Image Box", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/imagebox.png")));
		icons.put("Label", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/label.png")));
		icons.put("Password Box", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/password.png")));
		icons.put("Window", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/window.png")));
		icons.put("Panel", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/panel.png")));
		icons.put("Group Box", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/group.png")));
		icons.put("Progress Bar", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/progress.png")));
		icons.put("Horizontal Splitter", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/split_horizontal.png")));
		icons.put("Vertical Splitter", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/split_vertical.png")));
		icons.put("Checkbox", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/checkbox.png")));
		icons.put("Radio Button", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/radio.png")));
		icons.put("Dropdown", new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/dropdown.png")));
		arrow_expand = new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/expand.png"));
		arrow_expanded = new ImageIcon(ComponentTreeIconRenderer.class.getResource("/icons/expanded.png"));
	}

	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
		String item = value.toString();
		setIcon(icons.containsKey(item) ? icons.get(item) : expanded ? arrow_expanded : arrow_expand);
		return this;
	}
}