import javax.swing.JInternalFrame;
import javax.swing.ImageIcon;
import java.awt.datatransfer.DataFlavor;
import javax.swing.TransferHandler;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.Point;
import javax.swing.plaf.basic.BasicInternalFrameUI;
import java.awt.event.MouseMotionListener;
import java.awt.Component;
import java.awt.Dimension;
import java.util.Map;
import java.util.HashMap;

public class WindowVisualiser extends JInternalFrame {
	private int wvX, wvY, wvWidth, wvHeight;
	private boolean init = true;

	public WindowVisualiser(String title, int width, int height) {
		super(title, true, true, true, true);
		setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
		setLayout(null);
		super.setBounds(20, 20, width, height);
		this.wvX = 20;
		this.wvY = 20;
		this.wvWidth = width;
		this.wvHeight = height;
		setFrameIcon(new ImageIcon("icons/window.png"));
	
		setTransferHandler(new TransferHandler() {
			public boolean canImport(TransferHandler.TransferSupport support) {
				return true;
			}

			public boolean importData(TransferHandler.TransferSupport support) {
				String data = null;
				try {
					data = (String)(support.getTransferable()).getTransferData(DataFlavor.stringFlavor);
				} catch (Exception e) { }

				Point dropPoint = support.getDropLocation().getDropPoint();
				Insets intframeInsets = getInsets();
				Rectangle intframeBounds = getBounds();
				Rectangle intframeCpBounds = getContentPane().getBounds();
				dropPoint.translate(
					(((int)intframeBounds.getWidth() - (int)intframeCpBounds.getWidth()) - intframeInsets.right) * -1,
					(((int)intframeBounds.getHeight() - (int)intframeCpBounds.getHeight()) - intframeInsets.bottom) * -1
				);

				XElement element = ElementFactory.createDefault(data);
				System.out.println("Created");
				element.setProperty("top", new XPropertyInteger("top", "Top", (int)dropPoint.getY()));
				element.setProperty("left", new XPropertyInteger("left", "Left", (int)dropPoint.getX()));
				element.updateComponent();
				Editor.getEditorWindow().addElement(element);
				return true;
			}
		});
	}

	public void setMaximum(boolean b) { }

	public void setIcon(boolean b) { }

	public void setBounds(int x, int y, int width, int height) {
		boolean changeWidth = width != this.wvWidth;
		boolean changeHeight = height != this.wvHeight;
		boolean changeX = x != this.wvX;
		boolean changeY = y != this.wvY;

		if ((!changeWidth && !changeHeight) || (changeX || changeY))
			return;

		//width, height, x = bottom left
		//width, height, y = top right

		// if (changeWidth && changeHeight && changeX) {  //Bottom left drag
			// System.out.println("Width=" + width + ", wvwidth=" + this.wvWidth);
			// width = this.wvWidth;
		// }

		super.reshape(20, 20, width, height);

		this.wvX = x;
		this.wvY = y;
		this.wvWidth = width;
		this.wvHeight = height;
	}
}