import java.util.Map;
import java.util.LinkedHashMap;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

abstract class XElementBranch extends XElement {  //A branch can have children
	protected Map<String, XElement> children = new LinkedHashMap();

	public XElementBranch() {

	}

	public XElementBranch(String id) {
		super(id);
	}

	public void addChild(XElement element) {
		children.put(element.properties.get("id").getValue().toString(), element);
	}

	public void removeChildren() {
		children.clear();
	}
	
	public void removeChild(String id) {
		if (this.children.containsKey(id)) {
			System.out.println("Removing " + id + " from " + this.properties.get("id").getValue());
			children.remove(id);
		}
	}

	public XElement getChild(String id) {
		return children.get(id);
	}

	public XElement[] getChildren() {
		return this.children.values().toArray(new XElement[0]);
	}

	public boolean hasChildren() {
		return (this.children.size() != 0);
	}
	
	public void moveTo(int index, int new_index) {
		/*while (index != new_index) {
			System.out.println("Moving item at " + index + " to " + (index+1));
			Collections.swap(this.children.values(), index, index+1);
			index++;
		}*/
	}
}