import javax.swing.JLabel;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import java.awt.MouseInfo;
import java.awt.Point;
import javax.swing.SwingUtilities;
import java.awt.Cursor;
import javax.swing.BorderFactory;
import java.awt.Color;
import javax.swing.ImageIcon;
import java.awt.Image;

public class XImageBox extends XElementLeaf {
	public XImageBox() {

	}

	public XImageBox(String id, int width, int height, int top, int left) {
		super(id);
		this.setProperty("left", new XPropertyInteger("left", "Left", left));
		this.setProperty("top", new XPropertyInteger("top", "Top", top));
		this.setProperty("width", new XPropertyInteger("width", "Width", width));
		this.setProperty("height", new XPropertyInteger("height", "Height", height));
		this.setProperty("imagesource", new XPropertyBitmap("imagesource", "Image Source", "file:///C:/Users/James/Pictures/8b011e869ece11e28e8322000a1f9686_7.jpg"));
		this.setProperty("halign", new XPropertyHorizontalAlign("halign", "Horizontal Align", "Middle"));
		this.setProperty("valign", new XPropertyVerticalAlign("valign", "Vertical Align", "Middle"));
		this.generateComponent();
	}

	public void generateComponent() {
		final JLabel imagebox = new JLabel();
		imagebox.setBorder(BorderFactory.createLineBorder(Color.black));
		imagebox.setFocusable(false);
		imagebox.setCursor(new Cursor(Cursor.MOVE_CURSOR));
		this.component = (java.awt.Component)imagebox;
		this.updateComponent();

		final Point offset = new Point(-1, -1);

		imagebox.addMouseMotionListener(new MouseAdapter() {
			public void mouseDragged(MouseEvent evt) {
				if (offset.getX() == -1 && offset.getY() == -1) {
					offset.setLocation(MouseInfo.getPointerInfo().getLocation());
					SwingUtilities.convertPointFromScreen(offset, imagebox);
				}
				move(MouseInfo.getPointerInfo().getLocation(), offset);
			}
		});

		imagebox.addMouseListener(new MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
				offset.setLocation(-1, -1);
			}
		});
	}

	public void updateComponent() {
		JLabel imagebox = ((JLabel)this.component);
		imagebox.setIcon(new ImageIcon((Image)this.getProperty("imagesource").getValue()));
		imagebox.setLocation(
			(Integer)this.getProperty("left").getValue(),
			(Integer)this.getProperty("top").getValue()
		);
		imagebox.setSize(new Dimension(
			(Integer)this.getProperty("width").getValue(),
			(Integer)this.getProperty("height").getValue()
		));
		String valign = (String)this.getProperty("valign").getValue();
		if (valign.equals("Top")) {
			imagebox.setVerticalAlignment(JLabel.TOP);
		} else if (valign.equals("Bottom")) {
			imagebox.setVerticalAlignment(JLabel.BOTTOM);
		} else if (valign.equals("Middle")) {
			imagebox.setVerticalAlignment(JLabel.CENTER);
		}
		String halign = (String)this.getProperty("halign").getValue();
		if (halign.equals("Left")) {
			imagebox.setHorizontalAlignment(JLabel.LEFT);
		} else if (halign.equals("Right")) {
			imagebox.setHorizontalAlignment(JLabel.RIGHT);
		} else if (halign.equals("Middle")) {
			imagebox.setHorizontalAlignment(JLabel.CENTER);
		}
	}

	private void move(Point position, Point offset) {
		JLabel imagebox = ((JLabel)this.component);
		SwingUtilities.convertPointFromScreen(position, Editor.getEditorWindow().getWindowVisualiserContentPane());
		position.translate((int)offset.getX() * -1, (int)offset.getY() * -1);
		position.setLocation((int)(Math.rint((double) position.getX() / PreferenceManager.GRID_SIZE) * PreferenceManager.GRID_SIZE),
								(int)(Math.rint((double) position.getY() / PreferenceManager.GRID_SIZE) * PreferenceManager.GRID_SIZE));
		imagebox.setLocation(position);
		this.getProperty("left").setValue((int)(position.getX()));
		this.getProperty("top").setValue((int)(position.getY()));
	}
}