import javax.swing.DefaultCellEditor;

abstract class XProperty<T> {
	protected String name;
	protected String friendly_name;
	protected T value;
	protected String display_value;

	public XProperty(String name, String friendly_name, T value, String display_value) {
		this.name = name;
		this.friendly_name = friendly_name;
		this.value = value;
		this.display_value = display_value;
	}

	public String getName() {
		return this.name;
	}

	public String getFriendlyName() {
		return this.friendly_name;
	}

	public String getDisplayValue() {
		return this.display_value;
	}

	public void setDisplayValue(String display_value) {
		this.display_value = display_value;
	}

	public abstract T getValue();
	public abstract void setValue(T value);
	public abstract void setValueFromString(String value);
	public abstract DefaultCellEditor getCellEditor();
}