import xgui
from PIL import Image
from PIL import ImageFilter
from PIL import ImageEnhance
import wx

# Instantiate a GUI instance
gui = xgui.GUI()


# Define the slots

def loadImage():
	dlg = wx.FileDialog(gui.GetElementByID("Window1")._component, message="Choose a file", defaultFile="", style=wx.OPEN | wx.CHANGE_DIR)
	if dlg.ShowModal() == wx.ID_OK:
		path = dlg.GetPath()
		gui.GetElementByID("ImageBox1").SetImage(Image.open(path))
		print path
	dlg.Destroy()

def incBrightness():
	im = gui.GetElementByID("ImageBox1").GetImage()
	en = ImageEnhance.Brightness(im)
	en.enhance(2.0)
	gui.GetElementByID("ImageBox1").SetImage(im)

def decBrightness():
	im = gui.GetElementByID("ImageBox1").GetImage()
	en = ImageEnhance.Brightness(im)
	en.enhance(0.5)
	gui.GetElementByID("ImageBox1").SetImage(im)

def incContrast():
	im = gui.GetElementByID("ImageBox1").GetImage()
	en = ImageEnhance.Contrast(im)
	en.enhance(2.0)
	gui.GetElementByID("ImageBox1").SetImage(im)

def decContrast():
	im = gui.GetElementByID("ImageBox1").GetImage()
	en = ImageEnhance.Contrast(im)
	en.enhance(0.5)
	gui.GetElementByID("ImageBox1").SetImage(im)

def blur():
	im = gui.GetElementByID("ImageBox1").GetImage()
	im = im.filter(ImageFilter.BLUR)
	gui.GetElementByID("ImageBox1").SetImage(im)

def contour():
	im = gui.GetElementByID("ImageBox1").GetImage()
	im = im.filter(ImageFilter.CONTOUR)
	gui.GetElementByID("ImageBox1").SetImage(im)

def emboss():
	im = gui.GetElementByID("ImageBox1").GetImage()
	im = im.filter(ImageFilter.EMBOSS)
	gui.GetElementByID("ImageBox1").SetImage(im)

def findEdges():
	im = gui.GetElementByID("ImageBox1").GetImage()
	im = im.filter(ImageFilter.FIND_EDGES)
	gui.GetElementByID("ImageBox1").SetImage(im)


# Load, connect and display the GUI

gui.Load("image_editor.xgui")
gui.Connect([loadImage, incBrightness, decBrightness, incContrast, decContrast, blur, contour, emboss, findEdges])
gui.Display()